/*
 * Copyright (c) 2022 Jonathan Schleifer <js@nil.im>
 *
 * All rights reserved.
 *
 * This file is part of Obj3DEngine. It may be distributed under the terms of
 * the Q Public License 1.0, which can be found in the file LICENSE.QPL
 * included in the packaging of this file.
 *
 * Alternatively, it may be distributed under the terms of the GNU General
 * Public License, either version 2 or 3, which can be found in the file
 * LICENSE.GPLv2 or LICENSE.GPLv3 respectively included in the packaging of
 * this file.
 */

#import <ObjFW/ObjFW.h>

#import "O3DRenderer.h"

OF_ASSUME_NONNULL_BEGIN

@interface O3DEngine: OFObject
{
	id <O3DRenderer> _renderer;
}

@property (readonly, nonatomic) id <O3DRenderer> renderer;

+ (OFArray OF_GENERIC(Class <O3DRenderer>) *)availableRenderers;

- (instancetype)initWithRenderer: (Class <O3DRenderer>)renderer
			 options: (nullable OFDictionary
				      OF_GENERIC(OFString *, id) *)options;
@end

OF_ASSUME_NONNULL_END
